MODULE checker 
    implicit none

    PRIVATE
    PUBLIC:: keineLZ, sicherGenug, langGenug, Kreativ

CONTAINS

    FUNCTION keineLZ(pw)
        CHARACTER(*),INTENT(IN):: pw
        LOGICAL:: keineLZ
        INTEGER:: i

        keineLZ=.true.
        DO i = 1,len_trim(pw)
            IF(pw(i:i) == " ") THEN
                keineLZ = .false.
                EXIT
            END IF
        END DO
    END FUNCTION keineLZ

    FUNCTION sicherGenug(pw)
        CHARACTER(*),INTENT(IN):: pw
        LOGICAL:: sicherGenug
        INTEGER:: i, ascii
        LOGICAL:: gross, klein, ziffer
        gross = .false.
        klein = .false.
        ziffer = .false.

        DO i=1, LEN(pw)
            ascii = IACHAR(pw(i:i))
            IF(ascii >= 65 .AND. ascii <= 90) THEN
                gross = .true.
            ELSE IF(ascii >= 97 .AND. ascii <= 122) THEN
                klein = .true.  
            ELSE IF(ascii >= 48 .AND. ascii <= 57)THEN
                ziffer = .true.
            END IF    
        END DO
        sicherGenug = ziffer .AND. klein .AND. gross
    END FUNCTION sicherGenug

    FUNCTION langGenug(pw)
        CHARACTER(*),INTENT(IN):: pw
        LOGICAL:: langGenug
        langGenug = .false.
        IF(len_trim(pw) >= 8) langGenug = .true.
    END FUNCTION langGenug

    FUNCTION Kreativ(pw)
        CHARACTER(*),INTENT(IN):: pw
        LOGICAL:: kreativ
        INTEGER:: ios33
        CHARACTER(20):: help
        kreativ = .true. 
        OPEN(UNIT=33,FILE="BekanntePasswörter.txt",ACTION="READ",IOSTAT=ios33,STATUS="OLD")
        IF(ios33==0)THEN
            READ(33,*,IOSTAT=ios33) help
            DO WHILE(ios33 == 0)
                IF(pw == help) THEN
                    kreativ=.false.
                    EXIT
                END IF
                READ(33,*,IOSTAT=ios33) help
            END DO
        END IF
        CLOSE(33)
    END FUNCTION Kreativ

END MODULE checker

PROGRAM main
    USE checker
    IMPLICIT NONE

    CHARACTER(LEN=20):: nutzer, passwort, passwort2
    WRITE(*,*) "Please enter username!"
    READ(*,*) nutzer

    DO
        WRITE(*,*) "Please enter password twice."
        READ(*,*) passwort, passwort2

        IF(passwort == nutzer) THEN
            WRITE(*,*) "ERROR: Password and username are the same."
        ELSE IF(.NOT.keineLZ(passwort))THEN
            WRITE(*,*) "ERROR: Password contains sapces."
        ELSE IF(.NOT.langGenug(passwort))THEN
            WRITE(*,*) "ERROR: Password is not long enough."
        ELSE IF(.NOT.sicherGenug(passwort))THEN
            WRITE(*,*) "ERROR: Password is not save enough. "
        ELSE IF(.NOT.kreativ(passwort))THEN
            WRITE(*,*) "ERROR: Password is not creativ enough."
        ELSE IF(passwort /= passwort2)THEN
            WRITE(*,*) "ERROR: Password1 and passwort2 are not the same."
        ELSE
            WRITE(*,*) "Perfect!"
            EXIT
        END IF
    END DO

END PROGRAM main
