module aufgaben_mod
    use zeit_mod
    use wichtel_mod
    implicit none

    private
    public :: aufgabe, GET, PUT, change_zeit

    type aufgabe 
        character(len=20) :: name
        character(len=50) :: beschreibung
        type(zeit) :: soll ! notwendige time zum vollenden
        type(zeit) :: habe ! gearbeitete time
    end type

    interface GET
        module procedure einlesen_aufgabe
    end interface

    interface PUT
        module procedure ausgeben_aufgabe
    end interface

    interface change_zeit
        module procedure change_zeit_habe
    end interface
    
 contains

    subroutine einlesen_aufgabe(task)
        type(aufgabe), intent(out) ::  task

        write(*,*) "Was ist der Name der Aufgabe?"
        read(*,*) task%name

        write(*,*) "Was ist die Beschreibung der Aufgabe? Schreibe am Anfang und Ende ein ' oder ",'".' 
        read(*,*) task%beschreibung

        write(*,*) "Wie lange dauert die Aufgabe? (hh, mm, ss.sss)"
        call get(task%soll)

        write(*,*) "Wie lange wurde schon an der Aufgabe gearbeitet? (hh, mm, ss.sss)"
        call get(task%habe)
    end subroutine einlesen_aufgabe

    subroutine ausgeben_aufgabe(task)
        type(aufgabe), intent(in) :: task

        write(*,*) "Aufgabe: ", trim(task%name), " : ", trim(task%beschreibung)
        write(*,*) "Es wurden ", zeit_string(task%habe), " von ", zeit_string(task%soll), " gearbeitet."
        
    end subroutine ausgeben_aufgabe

    subroutine change_zeit_habe(task, time)
        type(aufgabe), intent(inout) :: task
        type(zeit), intent(in) :: time
    
        task%habe = time
    end subroutine change_zeit_habe

end module aufgaben_mod